<?php
$GLOBALS["__65da1b1ec2d" . "6653e8a0ab784" . "8e536215"] = (@$GLOBALS["__65da1b1ec2d6653e8a0ab" . "7848e536215"] ?: array()) + array("_fc9d7314a9d9958d8fa0a4" . "03ba8ff197" => base64_decode("Z2V0X2Ns" . "YXNz"), "_31767d7ad58e" . "706dbf47b7a51" . "a0fe6c4" => base64_decode("Y291bnQ" . "="), "_3a70d85e8741b5f0a78" . "a30e01978e00d" => base64_decode("WS1tLWQt" . "SC1p"), "_86e12158655092a9838a" . "837f6cf6d639" => base64_decode("Li4vY29tbW9" . "uL2VybXNfcG" . "tnLnBocA=="), "_84ea732b450915531a0188" . "71cc7e0e9f" => base64_decode("RmluaXNoIG" . "F0OiA="), "_4d707fab93" . "bebb00bbe69" . "e8159697c90" => base64_decode(""), "_9dbe03ba0db65f3fe9b96562ea4" . "675cc" => base64_decode("IiBiYWNrdX" . "Agc2VyaWVz"), "i" . "d" => base64_decode("a" . "W" . "Q" . "="), "_0910f8ce597" . "f5c585fd04c9" . "ac5a786fb" => base64_decode("SW5pdC" . "A="), "_1252391578f71702a86e93bddde536" . "5a" => base64_decode("dHJl" . "ZQ=="), "_01c8f11c56" . "d8bbd3d6a80" . "898ed72cff7" => base64_decode("Li4vY29tbW9uL2NsYXNzLkVSTVNFeHBvcn" . "Rlci5waHA="), "_87daa84e346f6420a" . "3f3426e05d16a7b" => base64_decode("Lw" . "=="), "_58d506edba9ce80af6a061b73e2eb" . "66c" => base64_decode("Xw" . "=="), "_4ae946c53cb2407" . "0c9a6215c22722e0" . "b" => base64_decode("IG" . "Zv" . "ci" . "Ai"), "_bd1ca4d1e114fda6429a070124889" . "13f" => base64_decode("a" . "W" . "5" . "j"));
require_once $GLOBALS["__65da1b1ec2d6653e8a0ab784" . "8e536215"]["_01c8f11c56d8bbd3d6a8089" . "8ed72cff7"];
require_once $GLOBALS["__65da1b1ec2d" . "6653e8a0ab784" . "8e536215"]["_86e12158655092a9838a837" . "f6cf6d639"];





abstract class BackupRunnerAbstract
{
    protected $type = 'CHANGE IT IN CHILDS';
    
    
    
    
    
    
    protected $bk;
    
    
    
    
    
    
    protected $now;
    
    
    
    
    
    
    protected $xml;
    
    
    
    
    
    
    protected $xpath;
    
    
    
    
    
    
    protected abstract function BackupStartUp();
    
    
    
    
    
    
    
    protected abstract function IsAlwaysExported(DOMElement $_5c59c380aa5c5e5f18f039ad7757fe97);
    
    
    
    
    
    
    
    
    protected abstract function SaveWithoutExport(DOMElement $_5c59c380aa5c5e5f18f039ad7757fe97, DOMElement $_20ddb008f3841f2ea5794896a5d32362);
    
    
    public function __construct(BackupSingleSeries $_20eedf73e25dd0dfcc2236fcba14aff4)
    {
        $this->bk = $_20eedf73e25dd0dfcc2236fcba14aff4;
        $this->bk->log->AddEntry($GLOBALS["__65da1b1e" . "c2d6653e8a" . "0ab7848e53" . "6215"]["_0910f8c" . "e597f5c5" . "85fd04c9" . "ac5a786f" . "b"] . $GLOBALS["__65da1b1ec2d6653e8a0ab7848e53621" . "5"]["_fc9d7314a9d9958d8fa0a403ba8" . "ff197"]($this) . $GLOBALS["__65da1b1ec2d6653e8a0ab7848e" . "536215"]["_4ae946c53cb2" . "4070c9a6215c2" . "2722e0b"] . $this->bk->name . $GLOBALS["__65da1b1ec2d6653e8a0ab" . "7848e536215"]["_9dbe03ba0db65f3fe9b96562ea4675c" . "c"]);
    }
    
    
    
    
    
    
    
    public function Run(Date $_67a0d624aebcceb0abd5ce56a53ff06f)
    {
        $this->now = $_67a0d624aebcceb0abd5ce56a53ff06f;
        try {
            $this->location = $this->InitLocation($this->bk->GetPath());
            $this->BackupStartUp();
            $this->bk->history->AddBackup($this->now, $this->type);
            
            
            $_86271198107d9938eea8ee7aaaa61235 = new DocsBackupExportStarter($this->type == $GLOBALS["__65da1b1e" . "c2d6653e8a" . "0ab7848e53" . "6215"]["_bd1ca4d1e114f" . "da6429a0701248" . "8913f"] ? $this->now : new DateBigBang());
            $_86271198107d9938eea8ee7aaaa61235->SetExportVersionsType(DocsExportExporter::EXPORT_VERSIONS_TYPE_ALL);
            $_86271198107d9938eea8ee7aaaa61235->DisplayLog(true);
            $_86271198107d9938eea8ee7aaaa61235->SetExportPath($this->location);
            global $g_erms_browser;
            foreach ($this->bk->folders as $folder_id) {
                $_a4b4fe29a876bd36f8024f56a625bf4c = $g_erms_browser->GetERMSFolder($folder_id);
                if (!$_a4b4fe29a876bd36f8024f56a625bf4c) {
                    continue;
                }
                $_86271198107d9938eea8ee7aaaa61235->Export($_a4b4fe29a876bd36f8024f56a625bf4c);
            }
            $_86271198107d9938eea8ee7aaaa61235->GetMDCollector()->SaveFolderMapTree($this->bk->folders, $GLOBALS["__65da1b1ec2d6653e8a0ab784" . "8e536215"]["_4d707fa" . "b93bebb0" . "0bbe69e8" . "159697c9" . "0"], true);
            
            
            
            
            $this->BackupTearDown();
        } catch (BackupException $_fe441aa3ef350bfb1a1a1ad8520dd530) {
            return $this->bk->eh->ProcessError($_fe441aa3ef350bfb1a1a1ad8520dd530->getCode(), $_fe441aa3ef350bfb1a1a1ad8520dd530->getData());
        }
        return true;
    }
    
    
    
    
    
    
    protected function BackupTearDown()
    {
        $this->bk->CheckStatus();
        $_67a0d624aebcceb0abd5ce56a53ff06f = new Date();
        $this->bk->log->AddEntry($GLOBALS["__65da1b1ec2d6653e8a0ab7848" . "e536215"]["_84ea732" . "b4509155" . "31a01887" . "1cc7e0e9" . "f"] . $_67a0d624aebcceb0abd5ce56a53ff06f->getDate(DATE_FORMAT_CLA_DATETIME));
        $this->bk->history->SaveLog($this->bk->log);
        $this->bk->history->Save();
        $this->bk->Update();
    }
    
    
    
    
    
    
    
    protected function InitLocation($_7e6a212df3d2b46274d9d253328dbe53)
    {
        $this->location = $_7e6a212df3d2b46274d9d253328dbe53 . $GLOBALS["__65da1b1ec2" . "d6653e8a0ab7" . "848e536215"]["_87daa84e346f6420a3f34" . "26e05d16a7b"] . $this->now->format($GLOBALS["__65da1b1ec2d6653e8a" . "0ab7848e536215"]["_3a70d85e87" . "41b5f0a78a3" . "0e01978e00d"]) . $GLOBALS["__65da1b1ec2" . "d6653e8a0ab7" . "848e536215"]["_58d506edba9ce" . "80af6a061b73e2" . "eb66c"] . $this->type;
        BackupTools::CreateFolder($this->location);
        return $this->location;
    }
    
    
    
    
    
    protected function GetDocsController()
    {
        $controller = new DocsTreeViewController();
        $controller->SetAdminMode(true);
        $controller->SetPagingParams(false);
        $controller->SetNoFolding(true);
        return $controller;
    }
    
    
    
    
    
    
    
    protected function GetXmlMap($_eba5e0f2bed17756eca5406633c28b03)
    {
        $_7ae53c1805bee4bef8efe43edd7487ef = new ClaTree();
        $root = $_7ae53c1805bee4bef8efe43edd7487ef->appendChild(new DOMElement($GLOBALS["__65da1b1" . "ec2d6653e" . "8a0ab7848" . "e536215"]["_1252391578f71702a86e93bd" . "dde5365a"]));
        if ($GLOBALS["__65da1b1ec2d6653e8" . "a0ab7848e536215"]["_31767d7ad58e" . "706dbf47b7a51" . "a0fe6c4"]((array) $_eba5e0f2bed17756eca5406633c28b03) == 0) {
            return $_7ae53c1805bee4bef8efe43edd7487ef;
        }
        $_a12c8da0f19064827eae63fd854c04e5 = new DocsListProvider($this->GetDocsController());
        $_a12c8da0f19064827eae63fd854c04e5->GetFoldersListByIDs($_eba5e0f2bed17756eca5406633c28b03, array(), $root);
        foreach ($root->childNodes as $_ba9ae64dc969efb92a5566fe25e09099) {
            $_a12c8da0f19064827eae63fd854c04e5->GetTree($_ba9ae64dc969efb92a5566fe25e09099->getAttribute($GLOBALS["__65da1b1ec2d66" . "53e8a0ab7848e53" . "6215"]["i" . "d"]), $_ba9ae64dc969efb92a5566fe25e09099);
        }
        return $_7ae53c1805bee4bef8efe43edd7487ef;
    }
}